/* Copyright 2001, Jan D. Wolter and Steven R. Weiss, All Rights Reserved. */

#include "sql.h"

#if defined(SQL_Q_CREATE)
void qry_auth_create();
#endif

#if defined(HAVEAUTH_GETPASS)
SQLhandle qry_auth_getpass(char *login);
#endif

#if defined(HAVEAUTH_WALK)
SQLhandle qry_auth_logins(int n);
#endif

#if defined(HAVEAUTH_SEEK)
SQLhandle qry_auth_logins_after(char *login, int n);
#endif

#if defined(HAVEAUTH_NEWPASS)
void qry_auth_newpass(char *login, char *pass);
#endif

#if defined(HAVEAUTH_ADD)
void qry_auth_add(char *login, char *pass, int uid, int gid, char *fname, char *dir, char *email, char *vc, int priv, int epriv);
#endif

#if defined(HAVEAUTH_DEL)
void qry_auth_del(char *login);
#endif

#if defined(SQL_Q_CREATE)
void qry_ident_create();
#endif

SQLhandle qry_ident_getpwnam(char *login);

#if defined(HAVEIDENT_GETPWUID)
SQLhandle qry_ident_getpwuid(int uid);
#endif

#if defined(HAVEIDENT_WALKPW)
SQLhandle qry_ident_users(int n);
#endif

#if defined(HAVEIDENT_WALK)
SQLhandle qry_ident_logins(int n);
#endif

#if defined(HAVEIDENT_SEEK)
SQLhandle qry_ident_logins_after(char *login, int n);
#endif

#if defined(HAVEIDENT_NEWFNAME)
void qry_ident_newfname(char *login, char *fname);
#endif

#if defined(HAVEIDENT_NEWGID)
void qry_ident_newgid(char *login, int gid);
#endif

#if defined(HAVEIDENT_NEWEMAIL)
void qry_ident_newemail(char *login, char *email, char *vc);
#endif

#if defined(HAVEIDENT_NEWPRIV)
void qry_ident_newpriv(char *login, int priv, int epriv);
#endif

#if defined(HAVEIDENT_ADD)
void qry_ident_add(char *login, int uid, int gid, char *fname, char *dir, char *email, char *vc, int priv, int epriv);
#endif

#if defined(HAVEIDENT_DEL)
void qry_ident_del(char *login);
#endif

#if defined(NEXTUID_SQL)
#if defined(SQL_Q_CREATE)
void qry_uid_create(void);
#endif
SQLhandle qry_uid_next(void);
SQLhandle qry_uid_peek(void);
SQLhandle qry_uid_curr(void);
#endif

#if defined(SQL_Q_CREATE)
void qry_group_create();
#endif

SQLhandle qry_group_gid_to_name(int gid);
SQLhandle qry_group_name_to_gid(char *gname);
SQLhandle qry_group_in_name(char *login, char *gname);
SQLhandle qry_group_in_gid(char *login, int gid);
SQLhandle qry_group_all(int n);
SQLhandle qry_group_mine(char *login, int n);
void qry_group_add(int gid, char *gname);
void qry_group_memadd(int gid, char *login);
void qry_group_del(char *gname);
void qry_group_memdel(char *gname, char *login);


#if defined(SQL_Q_CREATE)
void qry_sess_create();
#endif

SQLhandle qry_sess_get(char *sid);
void qry_sess_refresh(char *sid, int time);
void qry_sess_new(char *sid, char *login, int time, char *ip);
void qry_sess_kill(char *sid);
void qry_sess_reap(int time);
SQLhandle qry_sess_salt();

#if defined(SQL_Q_CREATE)
void qry_baai_create();
#endif

SQLhandle qry_baai_get(char *handle);
SQLhandle qry_baai_list();
void qry_baai_add(char *handle, char *type, int size, char *login,
    int uid, char *conf, int access, int date, char *desc, int link);
void qry_baai_edit(char *handle, char *type, int size, char *login,
    int uid, char *conf, int access, int date, char *desc, int link);
void qry_baai_link(char *handle);
void qry_baai_del(char *handle);

#ifdef CDB
void qry_cdb_create(void);
SQLhandle qry_cdb_new_conf(char *partname);
SQLhandle qry_cdb_conf_id(char *partname);
void qry_cdb_del_conf(char *partname);
void qry_cdb_new_item(char *itemid, int startdate, int postdate, int frozen,
			   int retired, int nresp, char *authlogin,
			   int authuid, char *authalias, char *title,
			   char *keywords, char *summary);
void qry_cdb_del_item(char * itemid);
SQLhandle qry_cdb_item_info(char * itemid);
void qry_cdb_update_sum_key(char *itemid, char *summary, char *keywords);
SQLhandle qry_cdb_related_items(char *string, int confid, int limit);
void qry_cdb_item_title(char * itemid, char *newtitle);
void qry_cdb_new_link(char * itemid, int confid, int item, int date);
void qry_cdb_del_link(char * itemid, int confid);
SQLhandle qry_cdb_n_links(char * itemid);
SQLhandle qry_cdb_links(char * itemid, int limit);
SQLhandle qry_cdb_link_info(int confid, int item);
SQLhandle qry_cdb_n_references(char * itemid);
SQLhandle qry_cdb_references(char * itemid, int n);
void qry_cdb_new_reference(char * itemid, char *url, int date, char *source,
			   char *title, char *excerpt, char *blog_name);
#endif
